const path = require('path');
import * as fs from "fs";
import { BizError } from "../util/bizError";
import { analysisXml } from "../util/myXML";
import { ServerConfig } from "../config/systemClass";
const os = require('os');

export let systemConfig =  new ServerConfig;

const ConfigName = "serverConfig.xml";
export async function initConfig() {
    try {
        let buff = fs.readFileSync(path.join(__dirname.substring(0,__dirname.indexOf("out")), ConfigName));
        let configStr = buff.toString();
        let configInfo:any = await analysisXml(configStr);
		if (!configInfo || !configInfo.config) throw new BizError('xml中无配置');
		else {
            
            let {port, sign, dbServer, imgUrl, imgFileUrl, qcc } = configInfo.config;
            systemConfig.port = parseInt(port[0]);

            systemConfig.dbSign = sign[0];
            systemConfig.dbPath = dbServer[0];
            
            systemConfig.imgUrl = imgUrl[0];
            systemConfig.imgFileUrl = imgFileUrl[0];
            // systemConfig.fileUrl = fileUrl[0];

            systemConfig.qccKey  = qcc[0].key[0];
            systemConfig.qccSecretKey  = qcc[0].SecretKey[0];

		}
        
        console.log("config init success");

    } catch(err) {
        console.log('ERROR => 服务器配置解析错误 请检查根目录下 serverConfig.xml 文件是否正确');
        console.log(err);
        throw new BizError("服务器配置解析错误 请检查根目录下 serverConfig.xml 文件是否正确");
    }
}

function analysisMongoConnectStr(path, port, dataBase, w, timeOutMs) {
    return `mongodb://${path}:${port}/${dataBase}?w=${w}&wtimeoutMS=${timeOutMs}`
}